import math
import matplotlib.pyplot as plt
import numpy as np

################# Function Definitions ##################################
def f(x):
    return 1/x

def midpoint_sum(f, interval, dx):
    # write your code here
    x=interval[0]+dx/2
    riemann_sum = 0
    while x <= interval[1]:
        riemann_sum = riemann_sum + f(x) * dx
        x = x + dx
    return riemann_sum

def indefinite_integral(f,x,dx):
    # approximates the indefinite integral.
    return midpoint_sum(f,[0,x],dx)

################# Variable Definitions ###################################
lower_bound = 0.0
upper_bound = 10

interval=[lower_bound, upper_bound]
dxs = [dx for dx in np.linspace(0.0001,2,1000)]

################# Plotting ###############################################
#x_values = np.linspace(lower_bound, upper_bound)
#y_values = [f(x) for x in x_values]


# Area under linear function: A=0.5*x² -> A(x=10) = 50
#error_res_sums = [(midpoint_sum(f, interval, dx)-50) for dx in dxs]

g = math.cos

x_values = np.linspace(lower_bound, upper_bound, 1000)
g_int_values = [math.sin(x) for x in x_values]
g_int_approx = [indefinite_integral(g, x, 0.1) for x in x_values]

#plt.plot(x_values, y_values)
#plt.plot(dxs, error_res_sums)
plt.plot(x_values,g_int_values, label="True G(x)")
plt.plot(x_values,g_int_approx, label="Approximated G(x)")
plt.legend()
plt.xlabel("x")
plt.ylabel("G(x)")
plt.grid()
plt.show()